import java.awt.*;
import java.util.Random;

public enum DecksType {
    Standard,
    Round,
    Triangular;

    public static IDrawingDecks random(int decksCount, Color bodyColor) {
        return switch (new Random().nextInt(DecksType.values().length)) {
            case 0 -> new DrawingDecks(decksCount, bodyColor);
            case 1 -> new DrawingRoundDecks(decksCount, bodyColor);
            case 2 -> new DrawingTriDecks(decksCount, bodyColor);
            default -> null;
        };
    }
}